package com.lanren.huhu.partner.dao;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.lanren.huhu.partner.domain.UserAgent;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;

@Mapper
public interface UserAgentMapper extends BaseMapper<UserAgent> {
    int updateBatch(List<UserAgent> list);

    int batchInsert(@Param("list") List<UserAgent> list);

    int insertOrUpdate(UserAgent record);

    int insertOrUpdateSelective(UserAgent record);

    /**
     * 按agentId查找上级 UserAgent
     * 注意!!!!!!!!!!!! 查找上级用的是字段 presenter_id
     * @param agentId
     * @return
     */
    @Select("SELECT b.* " +
            "FROM user_agent a " +
            "JOIN user_agent b on a.presenter_id=b.agent_id " +
            "WHERE a.agent_id=#{agentId} and b.agent_level<=4")
    UserAgent getParentAgent(Integer agentId);

    /**
     * 按uid查找下级 UserAgent
     */
    @Select("SELECT b.* " +
            "FROM user_agent a " +
            "JOIN user_agent b on a.presenter_id=b.agent_id " +
            "WHERE a.user_id=#{userId}")
    List<UserAgent> getChildrenByUserId(Integer userId);
}